"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
// eslint-disable-next-line @typescript-eslint/no-var-requires
var version = require("../package.json").version;
exports.default = (function (argv) {
    var program = new commander_1.default.Command();
    var packageFile;
    program
        .version("" + version)
        .arguments("[packageFile]")
        .action(function (arg) {
        packageFile = arg;
    })
        .option("-s, --strict", "strict mode")
        .option("-j, --json", "JSON output")
        .option("-c, --config", "inspect the config")
        .option("-f, --fix", "autofixing");
    program.parse(argv);
    var options = program.opts();
    var cliConfig = { packageFile: packageFile };
    if (options.fix !== undefined) {
        cliConfig.fix = options.fix;
    }
    if (options.strict !== undefined) {
        cliConfig.strict = options.strict;
    }
    if (options.json !== undefined) {
        cliConfig.json = options.json;
    }
    if (options.config !== undefined) {
        cliConfig.config = options.config;
    }
    return cliConfig;
});
