"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../constants");
var utils_1 = require("../utils");
var getMissingHooks = function (prefix, scripts) {
    var keys = Object.keys(scripts);
    var hooks = keys.filter(function (k) { return k.startsWith(prefix); });
    var hooksMissing = [];
    hooks.forEach(function (hookName) {
        var triggerName = hookName.substr(prefix.length);
        if (!keys.includes(triggerName)) {
            hooksMissing.push(triggerName);
        }
    });
    return hooksMissing;
};
exports.default = {
    name: "prepost-trigger-defined",
    isObjectRule: true,
    message: "some custom hooks ({{names}}) are missing their trigger script(s)",
    validate: function (scripts) {
        scripts = (0, utils_1.filterPackageScriptsByKeys)(scripts, constants_1.DEFAULT_NPM_HOOKS);
        var preHooksMissing = getMissingHooks("pre", scripts);
        var postHooksMissing = getMissingHooks("post", scripts);
        var allMissing = __spreadArray(__spreadArray([], preHooksMissing.map(function (s) { return "pre" + s; }), true), postHooksMissing.map(function (s) { return "post" + s; }), true);
        return allMissing.length < 1 ? true : allMissing;
    },
};
